
QGIS Application - Bug report #5547

[DB Manager] - Geometry type (MultiPolygon) does not match column type (Polygon)

2012-05-07 01:43 PM - Salvatore Larosa

Status: Closed

Priority: High

Assignee: Giuseppe Sucameli

Category: DB Manager

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 15140

Description

It seems related at #5328

drag & drop shp file throws this error:

Feature write errors:

Creation error for features from #0 to #128. Provider errors was: 

PostGIS error while adding features: ERROR:  Geometry type (MultiPolygon) does not match column type (Polygon)

Only 0 of 129 features written.

Instead SPIT:

The error was:

ERROR:  Geometry type (Polygon) does not match column type (MultiPolygon)

dataset to reproduce: http://urlin.it/2fe0e

Associated revisions

Revision 08e844f6 - 2012-11-29 01:16 AM - Giuseppe Sucameli

create multipart layers whether the input is a singlepart shapefile (fix #5547)

History

#1 - 2012-06-18 06:11 AM - Salvatore Larosa

- Target version deleted (Version 1.8.0)

- Category changed from Python plugins to DB Manager

#2 - 2012-08-13 08:35 AM - Giovanni Manghi

- Assignee set to Giuseppe Sucameli

#3 - 2012-08-16 10:09 AM - Maximilian L.

Same error on Windows 7.
#4 - 2012-08-17 12:34 AM - James Stott

Same error here too on Windows 7 64 bit.

Loads into PostGIS fine using PostGIS Shapefile and DBF Loader 2 from within pgAdmin III.

#5 - 2012-08-29 10:02 AM - Giovanni Manghi

- Operating System deleted (Linux)

- OS version deleted (Debian/wheezy)

master still affected

#6 - 2012-09-04 12:09 PM - Paolo Cavallini

- Target version set to Version 2.0.0

#7 - 2012-11-28 10:31 AM - Giuseppe Sucameli

Looking at http://www.gdal.org/ogr/drv_shapefile.html:

Note that when reading a Shapefile of type SHPT_ARC, the corresponding layer will be reported as of type wkbLineString, but depending on the

number of parts of each geometry, the actual type of the geometry for each feature can be either OGRLineString or OGRMultiLineString. The same

applies for SHPT_POLYGON shapefiles, reported as layers of type wkbPolygon, but depending on the number of parts of each geometry, the

actual type can be either OGRPolygon or OGRMultiPolygon.

It seems that he OGR shapefile driver always report singlepart geometry type though it contains multipart geometries.

I'm handling it within the QgsVectorLayerImport class.

#8 - 2012-11-28 04:17 PM - Giuseppe Sucameli

- Status changed from Open to Closed

Fixed in changeset commit:"08e844f6d06683caef38dea20b00ea30a530008f".

#9 - 2012-11-28 04:38 PM - Giuseppe Sucameli

Fixed for QGis Friendly Courses http://www.qgis.org/en/sponsorship/qgis-friendly-courses.html
